diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockBasket.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java
similarity index 89%
rename from game/core/src/main/java/net/minecraft/core/block/BlockBasket.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java
index 30043a126..5fe216bcb 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockBasket.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java
@@ -12,11 +12,12 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
 
-public class BlockBasket extends BlockTileEntity
+public class BlockLogicBasket extends BlockLogic
 {
-    protected BlockBasket(final String blockName, String namespaceId, int id, final Material material)
+    protected BlockLogicBasket(Block<?> block, final Material material)
     {
-        super(blockName, namespaceId, id, material);
+        super(block, material);
+        block.withEntity(TileEntityBasket::new);
     }
 
     @Override
@@ -49,12 +50,6 @@ public class BlockBasket extends BlockTileEntity
         return false;
     }
 
-    @Override
-    protected TileEntity getNewBlockEntity()
-    {
-        return new TileEntityBasket();
-    }
-
     public int getFillLevel(final WorldSource world, final int x, final int y, final int z)
     {
         final TileEntityBasket te = (TileEntityBasket) world.getBlockEntity(x, y, z);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockBed.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
similarity index 93%
rename from game/core/src/main/java/net/minecraft/core/block/BlockBed.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
index 7d3054006..6033321de 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockBed.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
@@ -9,15 +9,13 @@ import net.minecraft.core.enums.EnumSleepStatus;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 
-public class BlockBed extends Block {
+public class BlockLogicBed extends BlockLogic {
 
-	public BlockBed(String key, String namespaceId, int id) {
-		super(key, namespaceId, id, Material.wood);
+	public BlockLogicBed(Block<?> block) {
+		super(block, Material.wood);
 		setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.5625F, 1.0F);
 	}
 
@@ -33,7 +31,7 @@ public class BlockBed extends Block {
 			int dir = getDirection(meta);
 			x += headBlockToFootBlockMap[dir].getOffsetX();
 			z += headBlockToFootBlockMap[dir].getOffsetZ();
-			if(world.getBlockId(x, y, z) != id) {
+			if(world.getBlockId(x, y, z) != block.id()) {
 				return true;
 			}
 			meta = world.getBlockMetadata(x, y, z);
@@ -45,7 +43,7 @@ public class BlockBed extends Block {
 			int dir = getDirection(meta);
 			x += headBlockToFootBlockMap[dir].getOffsetX();
 			z += headBlockToFootBlockMap[dir].getOffsetZ();
-			if(world.getBlockId(x, y, z) == id) {
+			if(world.getBlockId(x, y, z) == block.id()) {
 				world.setBlockWithNotify(x, y, z, 0);
             }
 			player.addStat(Achievements.SLEEP_NETHER, 1);
@@ -96,10 +94,10 @@ public class BlockBed extends Block {
 		int metadata = world.getBlockMetadata(x, y, z);
 		int direction = getDirection(metadata);
 		if(isBlockFootOfBed(metadata)) {
-			if(world.getBlockId(x - headBlockToFootBlockMap[direction].getOffsetX(), y, z - headBlockToFootBlockMap[direction].getOffsetZ()) != id) {
+			if(world.getBlockId(x - headBlockToFootBlockMap[direction].getOffsetX(), y, z - headBlockToFootBlockMap[direction].getOffsetZ()) != block.id()) {
 				world.setBlockWithNotify(x, y, z, 0);
 			}
-		} else if(world.getBlockId(x + headBlockToFootBlockMap[direction].getOffsetX(), y, z + headBlockToFootBlockMap[direction].getOffsetZ()) != id) {
+		} else if(world.getBlockId(x + headBlockToFootBlockMap[direction].getOffsetX(), y, z + headBlockToFootBlockMap[direction].getOffsetZ()) != block.id()) {
 			world.setBlockWithNotify(x, y, z, 0);
 		}
 	}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockBedrock.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBedrock.java
similarity index 56%
rename from game/core/src/main/java/net/minecraft/core/block/BlockBedrock.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicBedrock.java
index 68477c5b2..f2df63cd7 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockBedrock.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBedrock.java
@@ -4,19 +4,19 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.world.World;
 
-public class BlockBedrock
-	extends Block
+public class BlockLogicBedrock
+	extends BlockLogic
 {
-	public BlockBedrock(String key, String namespaceId, int id, Material material)
+	public BlockLogicBedrock(Block<?> block, Material material)
     {
-		super(key, namespaceId, id, material);
+		super(block, material);
 	}
 
 	@Override
 	public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
-        if (world.getBlockId(x, y - 1, z) == Blocks.GLOWSTONE.id) {
-            ((BlockPortal) Blocks.PORTAL_PARADISE).tryToCreatePortal(world, x, y, z, DyeColor.SILVER);
+        if (world.getBlockId(x, y - 1, z) == Blocks.GLOWSTONE.id()) {
+            Blocks.PORTAL_PARADISE.getLogic().tryToCreatePortal(world, x, y, z, DyeColor.SILVER);
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockBoneShale.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBoneShale.java
similarity index 57%
rename from game/core/src/main/java/net/minecraft/core/block/BlockBoneShale.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicBoneShale.java
index 931f5124d..84ea53511 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockBoneShale.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBoneShale.java
@@ -6,27 +6,27 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-public class BlockBoneShale extends BlockFullyRotatable {
-    public BlockBoneShale(String translationKey, String namespaceId, int id, Material material) {
-        super(translationKey, namespaceId, id, material);
+public class BlockLogicBoneShale extends BlockLogicFullyRotatable {
+    public BlockLogicBoneShale(Block<?> block, Material material) {
+        super(block, material);
     }
 
     @Override
     public float blockStrength(World world, int x, int y, int z, Side side, Player player) {
-        float blockHardness = this.blockHardness;
+        float blockHardness = block.getHardness();
         final int meta = world.getBlockMetadata(x, y, z);
-        final Direction direction = BlockFullyRotatable.metaToDirection(meta);
+        final Direction direction = BlockLogicFullyRotatable.metaToDirection(meta);
         if (side != direction.getSide()) {
             blockHardness *= 66.6f;
         }
 
-        if (!player.canHarvestBlock(this))
+        if (!player.canHarvestBlock(block))
         {
             return 1.0F / blockHardness / 30F;
         }
         else
         {
-            return player.getCurrentPlayerStrVsBlock(this) / blockHardness / 30F;
+            return player.getCurrentPlayerStrVsBlock(block) / blockHardness / 30F;
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockBrazier.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBrazier.java
similarity index 76%
rename from game/core/src/main/java/net/minecraft/core/block/BlockBrazier.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicBrazier.java
index 24040cd72..1c85641e3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockBrazier.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBrazier.java
@@ -14,12 +14,12 @@ import net.minecraft.core.world.World;
 
 import java.util.Random;
 
-public class BlockBrazier
-    extends Block {
+public class BlockLogicBrazier
+    extends BlockLogic {
     private final boolean burning;
 
-    public BlockBrazier(String key, String namespaceId, int id, boolean burning) {
-        super(key, namespaceId, id, Material.metal);
+    public BlockLogicBrazier(Block<?> block, boolean burning) {
+        super(block, Material.metal);
         this.burning = burning;
     }
 
@@ -46,19 +46,20 @@ public class BlockBrazier
     public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced) {
         ItemStack heldItem = player.getHeldItem();
         if (heldItem != null && heldItem.getItem() instanceof ItemFireStriker && !burning) {
-            if (world.getBlock(x + 1, y, z) instanceof BlockFluid ||
-                world.getBlock(x - 1, y, z) instanceof BlockFluid ||
-                world.getBlock(x, y, z + 1) instanceof BlockFluid ||
-                world.getBlock(x, y, z - 1) instanceof BlockFluid) {
+            Block<?> b;
+            if ((b = world.getBlock(x + 1, y, z)) != null && b.getLogic() instanceof BlockLogicFluid ||
+                (b = world.getBlock(x - 1, y, z)) != null && b.getLogic() instanceof BlockLogicFluid ||
+                (b = world.getBlock(x, y, z + 1)) != null && b.getLogic() instanceof BlockLogicFluid ||
+                (b = world.getBlock(x, y, z - 1)) != null && b.getLogic() instanceof BlockLogicFluid) {
                 return false;
             }
-            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.BRAZIER_ACTIVE.id, 0);
+            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.BRAZIER_ACTIVE.id(), 0);
             heldItem.damageItem(1, player);
             world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D, "fire.ignite", 1.0F, world.rand.nextFloat() * 0.4F + 0.8F);
             return true;
         }
         if (heldItem == null && burning) {
-            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.BRAZIER_INACTIVE.id, 0);
+            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.BRAZIER_INACTIVE.id(), 0);
             return true;
         }
 
@@ -68,7 +69,7 @@ public class BlockBrazier
     @Override
     public void onActivatorInteract(World world, int x, int y, int z, TileEntityActivator activator, Direction direction) {
         if (burning) {
-            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.BRAZIER_INACTIVE.id, 0);
+            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.BRAZIER_INACTIVE.id(), 0);
         }
     }
 
@@ -82,9 +83,9 @@ public class BlockBrazier
     @Override
     public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
         if (!burning) return;
-        Block block = Blocks.blocksList[blockId];
-        if (block instanceof BlockFluid) {
-            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.BRAZIER_INACTIVE.id, 0);
+        Block<?> block = Blocks.blocksList[blockId];
+        if (block != null && block.getLogic() instanceof BlockLogicFluid) {
+            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.BRAZIER_INACTIVE.id(), 0);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockButton.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java
similarity index 95%
rename from game/core/src/main/java/net/minecraft/core/block/BlockButton.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java
index 5477ba41b..ee8c08f96 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockButton.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java
@@ -18,7 +18,7 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class BlockButton extends Block
+public class BlockLogicButton extends BlockLogic
 {
     public static final int MASK_POWERED = 0b0000_1000;
     public static final int MASK_DIRECTION = 0b0000_0111;
@@ -29,10 +29,10 @@ public class BlockButton extends Block
     public static final int SIDE_TOP = 5;
     public static final int SIDE_BOTTOM = 6;
 
-	public BlockButton(String key, String namespaceId, int id)
+	public BlockLogicButton(Block<?> block)
     {
-        super(key, namespaceId, id, Material.decoration);
-        setTicking(true);
+        super(block, Material.decoration);
+        block.setTicking(true);
     }
 
     @Override
@@ -293,28 +293,28 @@ public class BlockButton extends Block
         world.setBlockMetadataWithNotify(x, y, z, direction | MASK_POWERED);
         world.markBlocksDirty(x, y, z, x, y, z);
         world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, (double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D, "random.click", 0.3F, 0.6F);
-        world.notifyBlocksOfNeighborChange(x, y, z, id);
+        world.notifyBlocksOfNeighborChange(x, y, z, block.id());
         switch (direction) {
             case SIDE_WEST:
-                world.notifyBlocksOfNeighborChange(x - 1, y, z, id);
+                world.notifyBlocksOfNeighborChange(x - 1, y, z, block.id());
                 break;
             case SIDE_EAST:
-                world.notifyBlocksOfNeighborChange(x + 1, y, z, id);
+                world.notifyBlocksOfNeighborChange(x + 1, y, z, block.id());
                 break;
             case SIDE_NORTH:
-                world.notifyBlocksOfNeighborChange(x, y, z - 1, id);
+                world.notifyBlocksOfNeighborChange(x, y, z - 1, block.id());
                 break;
             case SIDE_SOUTH:
-                world.notifyBlocksOfNeighborChange(x, y, z + 1, id);
+                world.notifyBlocksOfNeighborChange(x, y, z + 1, block.id());
                 break;
             case SIDE_TOP:
-                world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
+                world.notifyBlocksOfNeighborChange(x, y + 1, z, block.id());
                 break;
             case SIDE_BOTTOM:
-                world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
+                world.notifyBlocksOfNeighborChange(x, y - 1, z, block.id());
                 break;
         }
-        world.scheduleBlockUpdate(x, y, z, id, tickDelay());
+        world.scheduleBlockUpdate(x, y, z, block.id(), tickDelay());
         return true;
     }
 
@@ -328,26 +328,26 @@ public class BlockButton extends Block
     {
         if((data & MASK_POWERED) != 0)
         {
-            world.notifyBlocksOfNeighborChange(x, y, z, id);
+            world.notifyBlocksOfNeighborChange(x, y, z, block.id());
             int direction = data & MASK_DIRECTION;
             switch (direction) {
                 case SIDE_WEST:
-                    world.notifyBlocksOfNeighborChange(x - 1, y, z, id);
+                    world.notifyBlocksOfNeighborChange(x - 1, y, z, block.id());
                     break;
                 case SIDE_EAST:
-                    world.notifyBlocksOfNeighborChange(x + 1, y, z, id);
+                    world.notifyBlocksOfNeighborChange(x + 1, y, z, block.id());
                     break;
                 case SIDE_NORTH:
-                    world.notifyBlocksOfNeighborChange(x, y, z - 1, id);
+                    world.notifyBlocksOfNeighborChange(x, y, z - 1, block.id());
                     break;
                 case SIDE_SOUTH:
-                    world.notifyBlocksOfNeighborChange(x, y, z + 1, id);
+                    world.notifyBlocksOfNeighborChange(x, y, z + 1, block.id());
                     break;
                 case SIDE_TOP:
-                    world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
+                    world.notifyBlocksOfNeighborChange(x, y + 1, z, block.id());
                     break;
                 case SIDE_BOTTOM:
-                    world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
+                    world.notifyBlocksOfNeighborChange(x, y - 1, z, block.id());
                     break;
             }
         }
@@ -404,26 +404,26 @@ public class BlockButton extends Block
             return;
         }
         world.setBlockMetadataWithNotify(x, y, z, meta & ~MASK_POWERED);
-        world.notifyBlocksOfNeighborChange(x, y, z, id);
+        world.notifyBlocksOfNeighborChange(x, y, z, block.id());
         int direction = meta & MASK_DIRECTION;
         switch (direction) {
             case SIDE_WEST:
-                world.notifyBlocksOfNeighborChange(x - 1, y, z, id);
+                world.notifyBlocksOfNeighborChange(x - 1, y, z, block.id());
                 break;
             case SIDE_EAST:
-                world.notifyBlocksOfNeighborChange(x + 1, y, z, id);
+                world.notifyBlocksOfNeighborChange(x + 1, y, z, block.id());
                 break;
             case SIDE_NORTH:
-                world.notifyBlocksOfNeighborChange(x, y, z - 1, id);
+                world.notifyBlocksOfNeighborChange(x, y, z - 1, block.id());
                 break;
             case SIDE_SOUTH:
-                world.notifyBlocksOfNeighborChange(x, y, z + 1, id);
+                world.notifyBlocksOfNeighborChange(x, y, z + 1, block.id());
                 break;
             case SIDE_TOP:
-                world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
+                world.notifyBlocksOfNeighborChange(x, y + 1, z, block.id());
                 break;
             case SIDE_BOTTOM:
-                world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
+                world.notifyBlocksOfNeighborChange(x, y - 1, z, block.id());
                 break;
         }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockCactus.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java
similarity index 84%
rename from game/core/src/main/java/net/minecraft/core/block/BlockCactus.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java
index a37b22b81..c62c3d4c6 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockCactus.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java
@@ -12,20 +12,18 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.helper.DamageType;
-import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class BlockCactus extends Block implements IBonemealable
+public class BlockLogicCactus extends BlockLogic implements IBonemealable
 {
 
-	public BlockCactus(String key, String namespaceId, int id)
+	public BlockLogicCactus(Block<?> block)
     {
-        super(key, namespaceId, id, Material.cactus);
-        setTicking(true);
+        super(block, Material.cactus);
+        block.setTicking(true);
         float f = 0.0625F;
         setBlockBounds(f, 0, f, 1 - f, 1, 1 - f);
     }
@@ -41,7 +39,7 @@ public class BlockCactus extends Block implements IBonemealable
         {
             int cactusHeight;
             cactusHeight = 1;
-            while (world.getBlockId(x, y - cactusHeight, z) == id) {
+            while (world.getBlockId(x, y - cactusHeight, z) == block.id()) {
                 cactusHeight++;
             }
             if(cactusHeight < 3)
@@ -49,7 +47,7 @@ public class BlockCactus extends Block implements IBonemealable
                 int i1 = world.getBlockMetadata(x, y, z);
                 if(i1 == 15)
                 {
-                    world.setBlockWithNotify(x, y + 1, z, id);
+                    world.setBlockWithNotify(x, y + 1, z, block.id());
                     world.setBlockMetadataWithNotify(x, y, z, 0);
                 } else
                 {
@@ -61,9 +59,9 @@ public class BlockCactus extends Block implements IBonemealable
 
     public void growCactusOnTop(World world, int x, int y, int z){
         int l;
-        for(l = 1; world.getBlockId(x, y + l, z) == id; l++) { }
+        for(l = 1; world.getBlockId(x, y + l, z) == block.id(); l++) { }
         if(world.isAirBlock(x, y+l, z)){
-            world.setBlockWithNotify(x, y + l, z, id);
+            world.setBlockWithNotify(x, y + l, z, block.id());
         }
     }
 
@@ -122,7 +120,7 @@ public class BlockCactus extends Block implements IBonemealable
         } else
         {
             int l = world.getBlockId(x, y - 1, z);
-            return Block.hasTag(l, BlockTags.GROWS_CACTI);
+            return Blocks.hasTag(l, BlockTags.GROWS_CACTI);
         }
     }
     @Override
@@ -137,7 +135,7 @@ public class BlockCactus extends Block implements IBonemealable
     public boolean onBonemealUsed(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         if(!world.isClientSide)
         {
-            ((BlockCactus)Blocks.blocksList[id]).growCactusOnTop(world, blockX, blockY, blockZ);
+            growCactusOnTop(world, blockX, blockY, blockZ);
             if (player == null || player.getGamemode().consumeBlocks())
             {
                 itemstack.stackSize--;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockCake.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCake.java
similarity index 75%
rename from game/core/src/main/java/net/minecraft/core/block/BlockCake.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicCake.java
index 485f4dc00..190a3da83 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockCake.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCake.java
@@ -4,12 +4,12 @@ import net.minecraft.core.item.Items;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockCake extends BlockEdible
+public class BlockLogicCake extends BlockLogicEdible
 {
 
-	public BlockCake(String key, String namespaceId, int id)
+	public BlockLogicCake(Block<?> block)
     {
-        super(key, namespaceId, id, 6, 3, () -> Items.FOOD_CAKE);
+        super(block, 6, 3, () -> Items.FOOD_CAKE);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockCandle.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCandle.java
similarity index 91%
rename from game/core/src/main/java/net/minecraft/core/block/BlockCandle.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicCandle.java
index 0d94b5329..1670188c4 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockCandle.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCandle.java
@@ -10,13 +10,11 @@ import net.minecraft.core.world.WorldSource;
 
 import java.util.Random;
 
-public class BlockCandle extends Block
+public class BlockLogicCandle extends BlockLogic
 {
-    public BlockCandle(String key, String namespaceId, int id, Material material)
+    public BlockLogicCandle(Block<?> block, Material material)
     {
-        super(key, namespaceId, id, material);
-        setTicking(true);
-
+        super(block, material);
         setBlockBounds(0.5f - 1.5f/16f, 0f, 0.5f - 1.5f/16f,
                        0.5f + 1.5f/16f, 0.5f, 0.5f + 1.5f/16f);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockChest.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java
similarity index 96%
rename from game/core/src/main/java/net/minecraft/core/block/BlockChest.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java
index 4dc99174e..c5ce4404e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockChest.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java
@@ -1,7 +1,6 @@
 package net.minecraft.core.block;
 
 import com.mojang.logging.LogUtils;
-import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityChest;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Mob;
@@ -15,10 +14,11 @@ import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
 
-public class BlockChest extends BlockTileEntity implements IPaintable {
+public class BlockLogicChest extends BlockLogic implements IPaintable {
 	private static final Logger LOGGER = LogUtils.getLogger();
-	public BlockChest(String key, String namespaceId, int id, Material material) {
-		super(key, namespaceId, id, material);
+	public BlockLogicChest(Block<?> block, Material material) {
+		super(block, material);
+		block.withEntity(TileEntityChest::new);
 	}
 	
 	@Override
@@ -270,7 +270,8 @@ public class BlockChest extends BlockTileEntity implements IPaintable {
 	}
 
 	public static boolean isChest(World world, int x, int y, int z) {
-		return Blocks.blocksList[world.getBlockId(x, y, z)] instanceof BlockChest;
+		Block<?> b;
+		return (b = Blocks.blocksList[world.getBlockId(x, y, z)]) != null && b.getLogic() instanceof BlockLogicChest;
 	}
 	
 	public static boolean isSingleChest(World world, int x, int y, int z) {
@@ -281,12 +282,7 @@ public class BlockChest extends BlockTileEntity implements IPaintable {
 		int meta = world.getBlockMetadata(x, y, z);
 		return isChest(world, x, y, z) && getTypeFromMeta(meta) == Type.SINGLE && getDirectionFromMeta(meta) == direction;
 	}
-	
-	@Override
-	protected TileEntity getNewBlockEntity() {
-		return new TileEntityChest();
-	}
-	
+
 	public void setDirection(World world, int x, int y, int z, Direction direction) {
 		if(isChest(world, x, y, z)) {
 			world.setBlockMetadataWithNotify(x, y, z, getMetaWithDirection(world.getBlockMetadata(x, y, z), direction));
@@ -412,12 +408,10 @@ public class BlockChest extends BlockTileEntity implements IPaintable {
 	@Override
 	public void setColor(World world, int x, int y, int z, DyeColor color) {
 		final int meta = world.getBlockMetadata(x, y, z);
-		world.setBlockAndMetadata(x, y, z, Blocks.CHEST_PLANKS_OAK_PAINTED.id, meta);
-		((IPaintable) Blocks.CHEST_PLANKS_OAK_PAINTED).setColor(world, x, y, z, color);
+		world.setBlockAndMetadata(x, y, z, Blocks.CHEST_PLANKS_OAK_PAINTED.id(), meta);
+		Blocks.CHEST_PLANKS_OAK_PAINTED.getLogic().setColor(world, x, y, z, color);
 	}
 
-	// Enum
-	
 	public enum Type{
 		
 		SINGLE, LEFT, RIGHT;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockChestLegacy.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChestLegacy.java
similarity index 88%
rename from game/core/src/main/java/net/minecraft/core/block/BlockChestLegacy.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicChestLegacy.java
index e836d3f1f..6824d42a4 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockChestLegacy.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChestLegacy.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.Global;
-import net.minecraft.core.block.BlockChest.Type;
+import net.minecraft.core.block.BlockLogicChest.Type;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityChest;
 import net.minecraft.core.block.material.Material;
@@ -13,10 +13,11 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
 @Deprecated
-public class BlockChestLegacy extends BlockTileEntity {
+public class BlockLogicChestLegacy extends BlockLogic {
 	
-	public BlockChestLegacy(String key, String namespaceId, int id) {
-		super(key, namespaceId, id, Material.wood);
+	public BlockLogicChestLegacy(Block<?> block) {
+		super(block, Material.wood);
+		block.withEntity(TileEntityChest::new);
 	}
 	
 	@Override
@@ -28,14 +29,9 @@ public class BlockChestLegacy extends BlockTileEntity {
 		else return null;
 	}
 
-	@Override
-	protected TileEntity getNewBlockEntity() {
-		return new TileEntityChest();
-	}
-	
 	public static boolean isLegacyChest(World world, int x, int y, int z) {
 		int id = world.getBlockId(x, y, z);
-		return id == Blocks.CHEST_LEGACY.id || id == Blocks.CHEST_LEGACY_PAINTED.id;
+		return id == Blocks.CHEST_LEGACY.id() || id == Blocks.CHEST_LEGACY_PAINTED.id();
 	}
 	
 	@Override
@@ -92,8 +88,8 @@ public class BlockChestLegacy extends BlockTileEntity {
 				facingDirection = Direction.SOUTH;
 			}
 			
-			meta = BlockChest.getMetaWithDirection(meta, facingDirection);
-			meta = BlockChest.getMetaWithType(meta, Type.SINGLE);
+			meta = BlockLogicChest.getMetaWithDirection(meta, facingDirection);
+			meta = BlockLogicChest.getMetaWithType(meta, Type.SINGLE);
 			
 			ItemStack[] items = getAndClearChestInventory(world, x, y, z);
 			
@@ -155,11 +151,11 @@ public class BlockChestLegacy extends BlockTileEntity {
 			if(type == Type.LEFT) otherType = Type.RIGHT;
 			if(type == Type.RIGHT) otherType = Type.LEFT;
 			
-			meta = BlockChest.getMetaWithDirection(meta, facingDirection);
-			meta = BlockChest.getMetaWithType(meta, type);
+			meta = BlockLogicChest.getMetaWithDirection(meta, facingDirection);
+			meta = BlockLogicChest.getMetaWithType(meta, type);
 			
-			otherMeta = BlockChest.getMetaWithDirection(otherMeta, facingDirection);
-			otherMeta = BlockChest.getMetaWithType(otherMeta, otherType);
+			otherMeta = BlockLogicChest.getMetaWithDirection(otherMeta, facingDirection);
+			otherMeta = BlockLogicChest.getMetaWithType(otherMeta, otherType);
 			
 			ItemStack[] items1 = getAndClearChestInventory(world, x, y, z);
 			ItemStack[] items2 = getAndClearChestInventory(world, otherChestX, y, otherChestZ);
@@ -206,15 +202,15 @@ public class BlockChestLegacy extends BlockTileEntity {
 		}
 		int legacyChestMeta = world.getBlockMetadata(x, y, z);
 		
-		Block oldBlock = world.getBlock(x, y, z);
-		Block newBlock = Blocks.CHEST_PLANKS_OAK;
+		Block<?> oldBlock = world.getBlock(x, y, z);
+		Block<?> newBlock = Blocks.CHEST_PLANKS_OAK;
 		
 		if(oldBlock == Blocks.CHEST_LEGACY_PAINTED) {
 			newBlock = Blocks.CHEST_PLANKS_OAK_PAINTED;
 			newMeta = newMeta | (legacyChestMeta << 4);
 		}
 		
-		world.setBlockAndMetadata(x, y, z, newBlock.id, newMeta);
+		world.setBlockAndMetadata(x, y, z, newBlock.id(), newMeta);
 		world.markBlockNeedsUpdate(x, y, z);
 	}
 }
